"use strict";
var $ = function (id) {
	return document.getElementById(id)
}
window.addEventListener("load", load, false);
document.addEventListener("mousemove", mousemove, false);
//window.addEventListener("resize", resize, false);
var mvb, stage;
var imageArray = new Array();
var brownImg = imageWithSrc("image/BrownAnim.png"),
	greenImg = imageWithSrc("image/GreenAnim.png"),
	orangeImg = imageWithSrc("image/OrangeAnim.png"),
	yellowImg = imageWithSrc("image/YellowAnim.png"),
	playerImg = imageWithSrc("image/player.png");

var imagesLoaded = 0;
var mx, my;
var w, h;
var bees = [];
function load(){
    mvb = $("mvb"); // gets the main Man Vs Bees canvas
    w = mvb.width = window.innerWidth - 1, h = mvb.height = window.innerHeight - 20;
    stage = new Stage(mvb);
	for(var i in imageArray){
                var io = imageArray[i];
		io.onload = imageLoad;
		io.src = io._src;
	}
}
function mousemove(e){
    mx = e.pageX;
    my = e.pageY;
}
function startGame(){
    var animations = initSpriteSheets();
	var alist = [animations.brown, animations.green, animations.orange, animations.yellow];
    for(var i = 0; i < 20; i++){
        var cbee = new Bee(alist[i % 4]);
        cbee.gotoAndPlay(Math.random() > 0.5 ? "fly" : "fly_h");
        cbee.name = "bee" + i;
        cbee.vX = cbee.vY = 0;
        cbee.x = (Math.random() * w) | 0;
        cbee.y = (Math.random() * h) | 0;
		bees.push(cbee);
        stage.addChild(cbee); 
    }
    Ticker.addListener(window);
    Ticker.useRAF = true;
    Ticker.setInterval(17);
//    Ticker.setInterval(500);
}
function tick(){
    stage.update();
}
function imageLoad(){
    if(++imagesLoaded == imageArray.length){
        startGame();
    }
}
function resize(){
    w = window.innerWidth, h = window.innerHeight;
    if(mvb !== undefined){
        mvb.width = w; mvb.height = h;
    }
}

function initSpriteSheets(){
    var spriteSheetBrown = new SpriteSheet({
        images: [brownImg],
        frames: { width: 43, height: 36, regX: 21.5, regY: 18},
        animations: {
            fly: [0, 1, "fly", 10]
        }
    });
    SpriteSheetUtils.addFlippedFrames(spriteSheetBrown, true, false, false);
    
    var spriteSheetGreen = new SpriteSheet({
        images: [greenImg],
        frames: { width: 43, height: 36, regX: 21.5, regY: 18},
        animations: {
            fly: [0, 1, "fly", 10]
        }
    });
    SpriteSheetUtils.addFlippedFrames(spriteSheetGreen, true, false, false);
    
    var spriteSheetOrange = new SpriteSheet({
        images: [orangeImg],
        frames: { width: 43, height: 36, regX: 21.5, regY: 18},
        animations: {
            fly: [0, 1, "fly", 10]
        }
    });
    SpriteSheetUtils.addFlippedFrames(spriteSheetOrange, true, false, false);

    var spriteSheetYellow = new SpriteSheet({
        images: [yellowImg],
        frames: { width: 43, height: 36, regX: 21.5, regY: 18},
        animations: {
            fly: [0, 1, "fly", 10]
        }
    });
    SpriteSheetUtils.addFlippedFrames(spriteSheetYellow, true, false, false);
	
	var spriteSheetPlayer = new SpriteSheet({
		images: [playerImg],
		frames: {width: 5, height: 10, regX: 2.5, regY: 5},
		animations: {
			walk: [0, 0, "walk", 1]
		}
	});
	
	return {
			brown: spriteSheetBrown,
			green: spriteSheetGreen,
			orange: spriteSheetOrange,
			yellow: spriteSheetYellow,
			player: spriteSheetPlayer
			};
}

function Bee(color){
    BitmapAnimation.call(this, color);
    this.isBee = true;
    this.dist = 2 * Math.random()/2 + 0.75;
    this.it = 0;
    this.tick = function(){
        var point = this.globalToLocal(mx, my);
        var cFrame = this.currentFrame;
        this.sa(point.x < 0 ? "fly_h" : "fly");
        this.currentFrame = cFrame;
        if(mx && my){
            this.moveTowards(mx, my);
        }
    }
	
    this.sa = function(anim){
        if(this.currentAnimation == anim) return;
        this.gotoAndPlay(anim);
    }
	
    this.moveTowards = function(tx, ty){
        if(isNaN(this.x) || isNaN(this.y)) console.log("X or y NaN");
        if(isNaN(tx) || isNaN(ty)) console.log("args NaN");
        var cx = this.x;
        var cy = this.y;
        var b = Math.sqrt((tx-cx)*(tx-cx) + (ty-cy)*(ty-cy));
        var rd = (Math.random() + 0.5)*this.dist;
        this.x = cx + rd*((tx - cx) / b)*(Math.random()*10 - 4);
        this.y = cy + rd*((ty - cy) / b)*(Math.random()*10 - 4);
/*        if(this.it % 2 == 0){
            this.x *= Math.random()/20 + 0.975;
            this.y *= Math.random()/20 + 0.975;
        }*/
        this.it++;
    }
	
    Ticker.addListener(this);
    this.regX = this.spriteSheet.frameWidth / 2 | 0;
    this.regY = this.spriteSheet.frameHeight / 2 | 0;
}
Bee.prototype = new BitmapAnimation();

function createBee(color){
    var bee = new BitmapAnimation(color);
    bee.regX = bee.spriteSheet.frameWidth / 2 | 0;
    bee.regY = bee.spriteSheet.frameHeight / 2 | 0;
    return bee;
}

function imageWithSrc(src){
	var i = new Image();
	i._src = src;
	imageArray.push(i);
        return i;
}